/*
 * H_STM32F4_UART_1.c
 *
 *  Created on: 2024/11/18
 *      Author: egaono-electronics
 */

#include "H_STM32F4_UART_1.h"



//----------------------------------------------------------
// UART制御パラメータ : UART1
//----------------------------------------------------------

//--------------------------------------
// UART handler declaration : UART1
//--------------------------------------
UART_HandleTypeDef Handle_UART1;
//--------------------------------------


//------------------------------------------------------
// Handle UART用パラメータの構造体の宣言 : UART1
//------------------------------------------------------
struct sParam_Handle_UARTx  GLB_structParam_Handle_UART1;
//------------------------------------------------------


// 送信Buffer : UART1
uint8_t GLB_uint8_aTx1_Buffer[def_Tx1_BufferSize];

// 受信Buffer : UART1
uint8_t GLB_uint8_aRx1_Buffer[def_Rx1_BufferSize];


// UART1通信処理用 受信データBuffer
uint8_t GLB_uint8_aReceiveData_UART1[def_Rx1_BufferSize];
//----------------------------------------------------------



//----------------------------------------------------------
// UART MSP Initialization
//----------------------------------------------------------
// 引数;
// UART_HandleTypeDef *huart :
//  pointer to a UART_HandleTypeDef structure that contains
//  the configuration information
//                      for the specified UART module.
//----------------------------------------------------------
void HAL_UART_MspInit(UART_HandleTypeDef *huart)
{
  GPIO_InitTypeDef  GPIO_InitStruct;


  if(huart->Instance == USART1)
  {
    // Enable GPIO Tx / Rx Clock
    __HAL_RCC_GPIOB_CLK_ENABLE();

    // Enable USART1 Clock
    __HAL_RCC_USART1_CLK_ENABLE();


    // UART1 TX GPIO pin configuration
    GPIO_InitStruct.Pin       = def_GPIO_PIN_x_UART1_TX;
    GPIO_InitStruct.Mode      = GPIO_MODE_AF_PP;
    GPIO_InitStruct.Pull      = GPIO_NOPULL;
    GPIO_InitStruct.Speed     = GPIO_SPEED_HIGH;
    GPIO_InitStruct.Alternate = GPIO_AF7_USART1;

    HAL_GPIO_Init(def_GPIOx_UART1_TX, &GPIO_InitStruct);



    // UART1 RX GPIO pin configuration
    GPIO_InitStruct.Pull      = GPIO_PULLUP;
    GPIO_InitStruct.Pin = def_GPIO_PIN_x_UART1_RX;
    GPIO_InitStruct.Alternate = GPIO_AF7_USART1;

    HAL_GPIO_Init(def_GPIOx_UART1_RX, &GPIO_InitStruct);


    // NVIC configuration for USART TC interrupt
    HAL_NVIC_SetPriority(USART1_IRQn, 12, 0);
    HAL_NVIC_EnableIRQ(USART1_IRQn);
  }
}



//----------------------------------------------------------
// UART MSP De-Initialization
//----------------------------------------------------------
// 引数;
// UART_HandleTypeDef *huart :
//  pointer to a UART_HandleTypeDef structure that contains
//  the configuration information
//                      for the specified UART module.
//----------------------------------------------------------
void HAL_UART_MspDeInit(UART_HandleTypeDef *huart)
{
  GPIO_InitTypeDef GPIO_InitStructure;


  if(huart->Instance == USART1)
  {
    // Reset peripherals
    __HAL_RCC_USART1_FORCE_RESET();
    __HAL_RCC_USART1_RELEASE_RESET();


    // Disable peripherals and GPIO Clocks
    // Configure UART Tx as alternate function
    HAL_GPIO_DeInit(def_GPIOx_UART1_TX, def_GPIO_PIN_x_UART1_TX);
    // Configure UART Rx as alternate function
    HAL_GPIO_DeInit(def_GPIOx_UART1_RX, def_GPIO_PIN_x_UART1_RX);


    //----------------------------------------------------------
    // GPIOの指定ピンを各モードに初期化
    //----------------------------------------------------------
    __HAL_RCC_GPIOB_CLK_ENABLE();

    GPIO_InitStructure.Pin = def_GPIO_PIN_x_UART1_TX;
    GPIO_InitStructure.Mode = GPIO_MODE_INPUT;
    GPIO_InitStructure.Pull = GPIO_PULLUP;
    GPIO_InitStructure.Speed = GPIO_SPEED_FREQ_HIGH;

    HAL_GPIO_Init(def_GPIOx_UART1_TX, &GPIO_InitStructure);


    __HAL_RCC_GPIOB_CLK_ENABLE();

    GPIO_InitStructure.Pin = def_GPIO_PIN_x_UART1_RX;
    GPIO_InitStructure.Mode = GPIO_MODE_INPUT;
    GPIO_InitStructure.Pull = GPIO_PULLUP;
    GPIO_InitStructure.Speed = GPIO_SPEED_FREQ_HIGH;

    HAL_GPIO_Init(def_GPIOx_UART1_RX, &GPIO_InitStructure);


    HAL_NVIC_DisableIRQ(USART1_IRQn);
  }
}
